/*****************************************************************************
*
* Atmel Corporation
*
* ̧			: sound_system2.c
* ߲		: IAR EWAAVR 3.20C
* 			: $Revision: 1.4 $
* t			: $Date: Monday, November 15, 2004 12:53:58 UTC $
*
* xҰ		: avr@atmel.com
*
* x޲	: ATmega8535
*
* pLq		: AVR335 ޼٘^Đ
*
*
****************************************************************************/

/*
]ނȂAS߰ނ܂B
ɏՕ1ް܂BɏՕtȂAɏՕ߰ނɏ܂B
1ƊɏՕ2؂芷Ȃް ڼ޽DataFlashǂ݂܂B
*/

#include <inavr.h>
#include <ioavr.h>
#include "dataflash.h"

// ^錾
void setup (void);
void erasing (void);
void recording (void);
void write_to_flash (unsigned char ad_data);
void playback (void);
void next_page_to_next_buffer (unsigned char active_buffer, unsigned int page_counter);
void active_buffer_to_speaker (unsigned char active_buffer);
void write_SPI(unsigned char data);

// S̕ϐ
volatile unsigned char wait = 0;

void setup(void)
{
	DDRB = 0xBD;								// SPI߰ď
												// SCK, MISO, MOSI,  CS, LED,  WP , RDYBSY, RST
												// PB7, PB6,  PB5,  PB4, PB3, PB2 ,  PB1,   PB0
												//  O    I     O     O    O    O      I      O
												//  1    0     1     1    1    1      0      1

	PORTB = 0xFF;								// SĂ̏o͂High(LED͏)ASĂ̓͂ٱ߂܂B
	DDRA = 0x00;								// ߰A͑Sē͎w
	PORTA = 0x00;
	DDRD = 0x10;								// PD4߰D͓͎w(PD4͏o)

	__enable_interrupt();						// S̊荞݋
}

void write_SPI(unsigned char data)
{
	SPDR = data;								// ްݒ
	while (!(SPSR & 0x80));						// ް]ҋ@
}

void erasing(void)
{
	unsigned int block_counter = 0;

	ACSR |= CLEARED;							// ς׸ސݒ
	SPCR = 0x5C;								// 荞݋֎~,呕u,MSBs,3,4OuSPI
	while (block_counter < 512)					// S򊮗܂ŉs
    {
		PORTB &= ~DF_CHIP_SELECT;				// DataFlash
		write_SPI(BLOCK_ERASE);					// ߕM
		write_SPI((char)(block_counter>>3));	// ڽM
		write_SPI((char)(block_counter<<5));
		write_SPI(0x00);
		PORTB |= DF_CHIP_SELECT;				// DataFlash֎~(sJn)
		block_counter++;						// vis
		while(!(PINB & 0x02));					// ҋ@
	}
	SPCR = 0x00;								// SPI֎~
}

void recording(void)
{
	unsigned char count;

	SPCR = 0x5C;								// 荞݋֎~,呕u,MSBs,3,4OuSPI
	ADMUX = 0x00;								// ADC0łA/DϊI
	ADCSRA = 0xD5;								// 32Ou̒PƕϊA/DϊJn
	do
	{
		do
		{
		} while(!(ADCSRA&(1<<ADIF)));			// A/Dϊҋ@
		count = 6;								// 66ۯɂȂlݒ(vmF)
		do										// 66ۯxҋ@
		{
		} while(--count);
		ADCSRA |= 0x40;							// VKA/DϊJn
		write_to_flash(ADC-0x1D5);				// A/Dϊl8ޯĂɕϊDataFlash֓]
	} while (!(PIND & 2));						// ^tJ܂ŏp
	ADCSRA = 0x00;								// A/Dϊ֎~
	SPCR = 0x00;								// SPI֎~
}

void write_to_flash(unsigned char flash_data)
{
	static unsigned int buffer_counter;
	static unsigned int page_counter;

	if((ACSR&CLEARED))							// ς݂ȂA
	{
		buffer_counter = 0;						// ɏՕv평
		page_counter = 0;						// ߰ތv평
		ACSR &= (~CLEARED);						// ς׸މ
	}
	while(!(PINB & 0x02));						// DataFlashmFҋ@
	PORTB &= ~DF_CHIP_SELECT;					// DataFlash
	write_SPI(BUFFER_1_WRITE);					// ɏՕ1ݖߕM
	write_SPI(0x00);							// аM
	write_SPI((char)(buffer_counter>>8));		// а+ɏՕڽ2ޯđM
	write_SPI((char)buffer_counter);			// ɏՕڽ8ޯđM
	write_SPI(flash_data);						// ɏՕްM
	PORTB |= DF_CHIP_SELECT;					// DataFlash֎~
	buffer_counter++;							// ɏՕvis
	if (buffer_counter > 528)					// ɏՕꂽȂA
	{
		buffer_counter = 0;						// ɏՕv평
		if (page_counter < 4096)				// ؂ĂȂȂA
		{
			PORTB &= ~DF_CHIP_SELECT;			// DataFlash
			write_SPI(B1_TO_MM_PAGE_PROG_WITHOUT_ERASE);	// ɏՕ1߰ނւ̏ȂݖߕM
			write_SPI((char)(page_counter>>6));	// ߰ ڽM
			write_SPI((char)(page_counter<<2));
			write_SPI(0x00);					// аM
			PORTB |= DF_CHIP_SELECT;			// DataFlash֎~(]()Jn)
			page_counter++;						// ߰ތvis
		}
		else									// ؂ꂽȂA
		{
			PORTB |= 0x08;						// LED
			while (!(PIND & 2));				// ^tJ܂őҋ@
		}
	}
}

void playback(void)
{
	unsigned int page_counter = 0;
	unsigned char active_buffer = 1;			// ɏՕ=ɏՕ1

	TCCR1A = 0x21;								// COM1Bgp8ޯPWMw
	TCNT1 = 0x00;								// /1v평
	TIFR = 0x04;								// /1ꊄ荞ݗv׸މ
	TIMSK = 0x04;								// /1ꊄ荞݋
	TCCR1B = 0x01;								// OuȂ/1n
	OCR1B = 0x00;								// PWMprl
	SPCR = 0x5C;								// 荞݋֎~,呕u,MSBs,3,4OuSPI
	next_page_to_next_buffer (active_buffer, page_counter);			// DataFlashŐ擪߰ނɏՕ1ɕ
	while (!(PINB & 0x02));						// DataFlash(߰ށˊɏՕʊ)ҋ@
	while ((page_counter < 4095)&(!(PIND & 4)))	// ؏I܂͍ĐtJ܂ōĐp
	{
		page_counter++;							// ߰ތvis
		next_page_to_next_buffer (active_buffer, page_counter);		// DataFlashŎ߰ނΉɏՕɕ
		active_buffer_to_speaker (active_buffer);					// 1߰ޕ(ΉɏՕް擾PWMݒ)
		if (active_buffer == 1)					// ݊Ȃ̂ɏՕ1ȂA
		{
			active_buffer++;					// ̊ɏՕƂĊɏՕ2ݒ
		}
		else									// ݊Ȃ̂ɏՕ2ȂA
		{
			active_buffer--;					// ̊ɏՕƂĊɏՕ1ݒ
		}
	}
	TIMSK = 0x00;								// /1ꊄ荞݋֎~
	TCCR1B = 0x00;								// /1~
	SPCR = 0x00;								// SPI֎~
}

void next_page_to_next_buffer (unsigned char active_buffer, unsigned int page_counter)
{
	while(!(PINB & 0x02));						// DataFlashmFҋ@
	PORTB &= ~DF_CHIP_SELECT;					// DataFlash
	if (active_buffer == 1)						// ɏՕɏՕ1ŁA
	{
		write_SPI(MM_PAGE_TO_B2_XFER);			// ߰ނɏՕ2֕(߰ށˊɏՕ2ǂݍݖߕM)
	}
	else										// ɏՕɏՕ2ŁA
	{
		write_SPI(MM_PAGE_TO_B1_XFER);			// ߰ނɏՕ1֕(߰ށˊɏՕ1ǂݍݖߕM)
	}
	write_SPI((char)(page_counter >> 6));		// ߰ ڽM
	write_SPI((char)(page_counter << 2));
	write_SPI(0x00);							// аM
	PORTB |= DF_CHIP_SELECT;					// DataFlash֎~(ʏJn)
}

#pragma vector = TIMER1_OVF_vect
__interrupt void out_now(void)
{
	ACSR |= T1_OVF;								// /1ꊄ荞ݔ׸ސݒ
}

void active_buffer_to_speaker (unsigned char active_buffer)
{ // ɏՕ̍ŏI޲Ă܂ŁAްǂPWM֐ݒ

	unsigned int buffer_counter = 528;			// ɏՕv평(~v)

	PORTB &= ~DF_CHIP_SELECT;					// DataFlash
	if (active_buffer == 1)						// ɏՕɏՕ1ŁA
	{
		write_SPI(BUFFER_1_READ);				// ɏՕ1ǂݍݖߕM
	}
	else										// ɏՕɏՕ2ŁA
	{
		write_SPI(BUFFER_2_READ);				// ɏՕ2ǂݍݖߕM
	}
	write_SPI(0x00);							// аM
	write_SPI(0x00);							// аM
	write_SPI(0x00);							// ɏՕJnڽM
	write_SPI(0x00);							// аM
	do
	{
		write_SPI(0xFF);						// Ή޲ ްM(޲Č̂߂аM)
		while(!(ACSR&T1_OVF));					// /1ꊄ荞ݔ܂őҋ@
		OCR1B = SPDR;							// Đް ޲Ď擾/PWMݒ
		ACSR &= (~T1_OVF);						// /1ꊄ荞ݔ׸މ
	} while (--buffer_counter);					// ɏՕv팸,528޲ĕp
	PORTB |= DF_CHIP_SELECT;					// DataFlash֎~
}

void main(void)
{
	setup();									// 

	for(;;)										// JԂ
	{
		if (!(PIND & 2))						// ^tŁA
		{
			PORTB &= 0xF7;						// LED_
			recording();						// ^
		}
		if (!(PIND & 1))						// tŁA
		{
			PORTB &= 0xF7;						// LED_
			erasing();							// 
			while (!(PIND & 1));				// tJ܂őҋ@
		}
		if (!(PIND & 4))						// ĐtŁA
		{
			PORTB &= 0xF7;						// LED_
			playback();							// Đ
			while (!(PIND & 4));				// ĐtJ܂őҋ@
		}
	PORTB |= 0x08;								// LED(ْ)
	}
}
